#include <SoftwareSerial.h> // libreria que permite establecer pines digitales para comunicacion serie
#include <Servo.h> 
SoftwareSerial BT(3, 2); //RXD y TXD
Servo   PIE_D;
Servo   ROD_D;
Servo   PIER_D;

Servo   PIE_IZ;
Servo   ROD_IZ; 
Servo   PIER_IZ; 
int tiempo=450,i=0,DATO = 100;

////pines servo 11,10,9,6,5,4
#define SPIE_IZ             5 
#define SROD_IZ             9 
#define SPIER_IZ            11 

#define SPIE_D              4 
#define SROD_D              6 
#define SPIER_D             10 
void setup()
 {
   BT.begin(9600);
   Serial.begin(9600);
   PIE_IZ.attach(SPIE_IZ);//por error 88 es su noventa por lo que hay que desfasar su fase 2 grados
   ROD_IZ.attach(SROD_IZ);//por error 91 es su noventa por lo que hay que desfasar su fase 1 grados  
   PIER_IZ.attach(SPIER_IZ ); 
   
   PIE_D.attach(SPIE_D);
   ROD_D.attach(SROD_D);  
   PIER_D.attach(SPIER_D); //por error 83 es su noventa por lo que hay que desfasar su fase 7 grados
 }
 
void loop()
{
if (BT.available()>0){      // si hay informacion disponible desde modulo
  // Almacena la información del botón en la variable DATO
   delay(1);
  String codigo = String(char(BT.read()));
  codigo += char(BT.read());
  DATO=codigo.toInt(); 
  PIE_IZ.attach(SPIE_IZ);//por error 88 es su noventa por lo que hay que desfasar su fase 2 grados
   ROD_IZ.attach(SROD_IZ);//por error 91 es su noventa por lo que hay que desfasar su fase 1 grados  
   PIER_IZ.attach(SPIER_IZ ); 
   
   PIE_D.attach(SPIE_D);
   ROD_D.attach(SROD_D);  
   PIER_D.attach(SPIER_D); //por error 83 es su noventa por lo que hay que desfasar su fase 7 grados
   Serial.println(DATO); 
switch(DATO){
    case 1:
    caminar_frente();
    break;
    
    case 2:
    girar_izquierda();
    break;

    case 90:
    configuracion_inicial_servos_90();
    break;

    case 3:
    girar_derecha();
    break;
    
    case 4:
    caminar_atras();
    break;

    case 5:
    pata_coja_izquierda();
    break;

    case 6:
    agacharse();
    break;
    
    case 7:
    pata_coja_derecha();
    break;

    case 8:
    paso_de_baile_izquierda();
    break; 

    case 9:
    twerk();
    break;

    case 10:
    
    paso_de_baile_derecha();
    break;
  } 
   PIE_IZ.detach();//por error 88 es su noventa por lo que hay que desfasar su fase 2 grados
   ROD_IZ.detach();//por error 91 es su noventa por lo que hay que desfasar su fase 1 grados  
   PIER_IZ.detach(); 
   
   PIE_D.detach();
   ROD_D.detach();  
   PIER_D.detach(); //por error 83 es su noventa por lo que hay que desfasar su fase 7 grados
}  
}
////////////////////////
void poner90grados(){
  PIE_D.write(90);
}
void caminar_frente()
{
  inclinacion_pizq_120_fuera() ;
  delay(100);
  mover_p_der_adelante();
  delay(100);
  mover_pie_i_centro_90();
  delay(100);
  inclinacion_pdere_120_fuera();
  delay(100);
  mover_p_izq_adelante();
  delay(100);
  mover_pie_d_centro_90();
  delay(100);
 } 
 void caminar_atras()
 {
 inclinacion_pizq_120_fuera() ;
 delay(100);
  mover_p_der_atras();
   delay(100);
  mover_pie_i_centro_90();
   delay(100);
  inclinacion_pdere_120_fuera();
   delay(100);
  mover_p_izq_atras();
   delay(100);
  mover_pie_d_centro_90(); 
 }
 void agacharse()
{
    PIER_IZ.write(60);
    PIER_D.write(113);
    delay(tiempo);
    ROD_IZ.write(126);
    ROD_D.write(55);
    delay(tiempo);
    PIE_IZ.write(88);
    PIE_D.write(90);
    delay(tiempo);  
 } 
void mover_pie_i_centro_90()
{
  PIE_IZ.write(88);
  delay(tiempo);
}
void mover_pie_d_centro_90()
{
  PIE_D.write(90);
  delay(tiempo);
}
void inclinacion_pdere_120_fuera() 
{
    PIE_IZ.write(103);
    delay(200);
    PIER_D.write(83);
    ROD_D.write(90);
    PIE_D.write(105);
    delay(tiempo);
}
void inclinacion_pizq_120_fuera() 
{
    PIE_D.write(75); //inclino pie derecho como ayuda
    delay(200);
    PIER_IZ.write(90);
    ROD_IZ.write(91);
    PIE_IZ.write(73);
    delay(tiempo);
}
void inclinacion_pdere_80_dentro() 
{
    PIE_IZ.write(87);
    delay(200);
    PIER_D.write(83);
    ROD_D.write(90);
    PIE_D.write(85);
    delay(tiempo);
}
void inclinacion_pizq_80_dentro() 
{
    PIE_D.write(105); //inclino pie derecho como ayuda
    delay(200);
    PIER_IZ.write(90);
    ROD_IZ.write(91);
    PIE_IZ.write(105);
    delay(tiempo);
}
void configuracion_inicial_servos_90() 
{
    PIER_IZ.write(90);
    PIER_D.write(83);
    delay(tiempo);
    ROD_IZ.write(91);
    ROD_D.write(90);
    delay(tiempo);
    PIE_IZ.write(88);
    PIE_D.write(90);
    delay(tiempo);  
}

void mover_p_izq_adelante()
{
    PIER_IZ.write(65);
    ROD_IZ.write(71);
    PIE_IZ.write(88);
    delay(tiempo);
}


void mover_p_der_adelante()
{
    PIER_D.write(108);
    ROD_D.write(110);
    PIE_D.write(90);
    delay(tiempo);
}
void mover_p_der_atras()
{
    PIER_D.write(58);
    ROD_D.write(70);
    PIE_D.write(90);
    delay(tiempo);
}
void mover_p_izq_atras()
{
    PIER_IZ.write(115);
    ROD_IZ.write(111);
    PIE_IZ.write(88);
    delay(tiempo);
}

void paso_de_baile_izquierda()
{
   PIER_IZ.write(110);
   ROD_IZ.write(111);
   PIE_IZ.write(88);
   delay(tiempo*2);
   PIER_D.write(103);
   ROD_D.write(110);
   PIE_D.write(90);
   delay(tiempo*2);
}
void paso_de_baile_derecha()
{
   PIER_D.write(70);
   ROD_D.write(63);
   PIE_D.write(90);
   delay(tiempo*2);
   PIER_IZ.write(70);
   ROD_IZ.write(71);
   PIE_IZ.write(88);
   delay(tiempo*2);
}

void twerk()
{
    PIER_IZ.write(60);
    PIER_D.write(113);
    delay(tiempo);
    ROD_IZ.write(41);
    ROD_D.write(140);
    delay(tiempo);
    PIE_IZ.write(88);
    PIE_D.write(90);
    delay(tiempo);
    ROD_IZ.write(71);
    ROD_D.write(110);
    delay(tiempo*3);  
    ROD_IZ.write(41);
    ROD_D.write(140);
    delay(tiempo*3);
    ROD_IZ.write(71);
    ROD_D.write(110);
    delay(tiempo*3); 
    ROD_IZ.write(41);
    ROD_D.write(140);
    delay(tiempo*3); 
}

void pata_coja_izquierda()
{
 inclinacion_pizq_120_fuera() ;
 delay(100);
 PIER_D.write(113);
 delay(tiempo);  
}
void pata_coja_derecha()
{
  inclinacion_pdere_120_fuera();
  delay(tiempo);
  PIER_IZ.write(60);
  delay(tiempo);  
}
void girar_derecha()
{
 inclinacion_pizq_120_fuera() ;
 delay(100);
 PIER_D.write(123);
 delay(tiempo);
 PIER_D.write(83);
 delay(tiempo); 
 PIER_D.write(123);
 delay(tiempo);
 PIER_D.write(83);
 delay(tiempo); 
 configuracion_inicial_servos_90(); 
}
void girar_izquierda()
{
 inclinacion_pdere_120_fuera();
 delay(tiempo);
 PIER_IZ.write(50);
 delay(tiempo);
 PIER_IZ.write(90);
 delay(tiempo);
 PIER_IZ.write(50);
 delay(tiempo);
 PIER_IZ.write(90);
 delay(tiempo);
 configuracion_inicial_servos_90(); 
}
